package org.nakedobjects.nos.client.web;

import org.nakedobjects.nof.core.util.AboutNakedObjects;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.component.ViewPane;
import org.nakedobjects.nos.client.web.request.Action;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.Request;

class About implements Action {

    public void execute(Request request, Context context, Page page) {
        ViewPane content = page.getViewPane();
        content.setTitle("About", null);
        
        content.add(context.getComponentFactory().createInlineBlock("about", AboutNakedObjects.getApplicationName(), null));
        content.add(context.getComponentFactory().createInlineBlock("about", AboutNakedObjects.getApplicationVersion(), null));
        content.add(context.getComponentFactory().createInlineBlock("about", AboutNakedObjects.getApplicationCopyrightNotice(), null));

        content.add(context.getComponentFactory().createInlineBlock("about", AboutNakedObjects.getFrameworkName(), null));
        content.add(context.getComponentFactory().createInlineBlock("about", AboutNakedObjects.getFrameworkVersion(), null));
        content.add(context.getComponentFactory().createInlineBlock("about", AboutNakedObjects.getFrameworkCopyrightNotice(), null));
    }

    public String name() {
        return "about";
    }
    
}

// Copyright (c) Naked Objects Group Ltd.
