package org.nakedobjects.nos.client.web;

import java.util.StringTokenizer;

import org.nakedobjects.nof.core.conf.Configuration;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.component.ViewPane;
import org.nakedobjects.nos.client.web.request.Action;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.Request;

class SwapUser implements Action {
    private static final String NAKEDOBJECTS_USERS = Configuration.ROOT + "exploration.users";

    public void execute(Request request, Context context, Page page) {
        ViewPane content = page.getViewPane();
        content.setTitle("Swap Exploration User", null);

        // TODO pick out users from the perspectives, but only show when in exploration mode
        String users = NakedObjectsContext.getConfiguration().getString(NAKEDOBJECTS_USERS);
        if(users != null) {
            StringTokenizer st = new StringTokenizer(users, ",");
            if (st.countTokens() > 0) {
                while (st.hasMoreTokens()) {
                    String token = st.nextToken();
                    int end = token.indexOf(':');
                    if (end == -1) {
                        end = token.length();
                    }
                    final String name = token.substring(0, end).trim();
                    
                    content.add(context.getComponentFactory().createUserSwap(name));
                }
            }
        }

        
        
        // TODO find user list and interate through them
        /*
        content.add(context.getFactory().createInlineBlock("title", AboutNakedObjects.getApplicationName(), null));
        content.add(context.getFactory().createInlineBlock("title", AboutNakedObjects.getApplicationVersion(), null));
        content.add(context.getFactory().createInlineBlock("title", AboutNakedObjects.getApplicationCopyrightNotice(), null));

        content.add(context.getFactory().createInlineBlock("title", AboutNakedObjects.getFrameworkName(), null));
        content.add(context.getFactory().createInlineBlock("title", AboutNakedObjects.getFrameworkVersion(), null));
        content.add(context.getFactory().createInlineBlock("title", AboutNakedObjects.getFrameworkCopyrightNotice(), null));
        */
    }

    public String name() {
        return "swapuser";
    }    
}

// Copyright (c) Naked Objects Group Ltd.
