package org.nakedobjects.nos.client.web.component;

import org.nakedobjects.noa.adapter.NakedCollection;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedValue;
import org.nakedobjects.noa.reflect.NakedObjectField;
import org.nakedobjects.noa.reflect.NakedObjectAction.Type;

public interface ComponentFactory {
    Component createAddOption(String id, String id2);

    Block createBlock(String style, String description);

    Component createBreadCrumbs(String[] names, boolean[] isLinked);

    Component createCollectionIcon(NakedObjectField field, NakedCollection collection, String id);

    DebugPane createDebugPane();

    Component createEditOption(String id);

    Component createErrorMessage(Exception e, boolean isDebug);

    Form createForm(String id, String action, int step, int noOfPages, boolean b);

    Component createHeading(String string);

    Component createInlineBlock(String style, String text, String description);

    Component createSubmenu(String menuName, Component[] items);

    Component createMenuItem(String actionId, String name, String description, String status, Type type, boolean hasParameters, String targetObjectId);

    Component createCollectionIcon(NakedCollection object, String collectionId);
    
    Component createObjectIcon(NakedObject object, String objectId, String style);
    
    Component createObjectIcon(NakedObjectField field, NakedObject object, String objectId, String style);

    Page createPage();

    Component createRemoveOption(String id, String elementId, String id2);

    Component createService(String objectId, String title, String iconName);

    Table createTable(int noColumns, boolean withSelectorColumn);
    
    Component createUserSwap(final String name) ;
    
    Component createValueField(NakedObjectField field, NakedValue value, boolean multiLine, boolean wrap, boolean isEditable);

    Component createLink(String link, String name, String description);
}


// Copyright (c) Naked Objects Group Ltd.
