package org.nakedobjects.nos.client.web.html;

import java.io.PrintWriter;

import org.nakedobjects.nos.client.web.component.Component;


public abstract class AbstractComponent implements Component {
    private String id;
    private String cls;

    public void setClass(String cls) {
        this.cls = cls;
    }

    public void setId(String id) {
        this.id = id;
    }

    protected void writeTag(PrintWriter writer, String tagName) {
        tag(writer, tagName);
        writer.print(">");
    }

    private void tag(PrintWriter writer, String tagName) {
        writer.print("<");
        writer.print(tagName);
        if (id != null) {
            writer.print(" id=\"");
            writer.print(id);
            writer.print("\"");
        }
        if (cls != null) {
            writer.print(" class=\"");
            writer.print(cls);
            writer.print("\"");
        }
    }

}

// Copyright (c) Naked Objects Group Ltd.
