package org.nakedobjects.nos.client.web.html;

import java.io.PrintWriter;

import org.nakedobjects.noa.adapter.NakedCollection;
import org.nakedobjects.nos.client.web.component.Component;
import org.nakedobjects.nos.client.web.component.ImageLookup;
import org.nakedobjects.nos.client.web.request.Request;


public class CollectionIcon implements Component {
    private final NakedCollection collection;
    private final String id;
    private final String description;

    public CollectionIcon(final NakedCollection element, final String description, final String id) {
        this.collection = element;
        this.description = description;
        this.id = id;
    }

    public void write(PrintWriter writer) {
        writer.print("<div class=\"item\">");
        writer.print("<a href=\"");
        writer.print(Request.COLLECTION_COMMAND + ".app?id=");
        writer.print(id);
        writer.print("\"");
        if (description != null) {
            writer.print(" title=\"");
            writer.print(description);
            writer.print("\"");
        }
        writer.print("><img src=\"images/");
        writer.print(ImageLookup.image(collection.getElementSpecification()));
        writer.print("\" alt=\"");
        String singularName = collection.getElementSpecification().getSingularName();
        writer.print(singularName);
        writer.print(" collection\" />");
        writer.print(collection.titleString());
        writer.print("</a>");

        writer.println("</div>");

    }

}

// Copyright (c) Naked Objects Group Ltd.
