package org.nakedobjects.nos.client.web.html;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.nakedobjects.nos.client.web.component.Component;

public class CompositeComponent implements Component {
    private List content = new ArrayList();

    public void write(PrintWriter writer) {
        writeBefore(writer);
        Iterator iterator = content.iterator();
        while (iterator.hasNext()) {
            Component component = (Component) iterator.next();
            write(writer, component);
        }
        writeAfter(writer);
        writer.println();
    }

    protected void write(PrintWriter writer, Component component) {
        component.write(writer);
    }

    protected void writeBefore(PrintWriter writer) {
    }

    protected void writeAfter(PrintWriter writer) {
    }
    
    public void add(Component component) {
        content.add(component);
    }

}


// Copyright (c) Naked Objects Group Ltd.
