package org.nakedobjects.nos.client.web.html;

import java.io.PrintWriter;

import org.nakedobjects.nos.client.web.component.Block;
import org.nakedobjects.nos.client.web.component.Component;


public class Div extends CompositeComponent  implements Block{
    private final String className;
    private final String id;
    private final String description;

    public Div(final String className, final String description) {
        this.className = className;
        this.description = description;
        id = null;
    }

    public Div(final String className, final String description, final String id) {
        this.description = description;
        this.className = className;
        this.id = id;
    }

    public void write(PrintWriter writer) {
        super.write(writer);
    }

    protected void writeBefore(PrintWriter writer) {
        writer.print("<div");
        if (className != null) {
            writer.print(" class=\"");
            writer.print(className);
            writer.print("\"");
        }
        if (id != null) {
            writer.print(" id=\"");
            writer.print(id);
            writer.print("\"");
        }
        if (description != null) {
            writer.print(" title=\"");
            writer.print(description);
            writer.print("\"");
        }
        writer.print(">");
    }

    protected void writeAfter(PrintWriter writer) {
        writer.println("</div>");
    }

    public void add(Component component) {
        super.add(component);
    }

    public void add(String text) {
        super.add(new Html(text));
    }

}

// Copyright (c) Naked Objects Group Ltd.
