package org.nakedobjects.nos.client.web.html;

import java.io.PrintWriter;

import org.nakedobjects.nos.client.web.component.Block;
import org.nakedobjects.nos.client.web.component.Component;
import org.nakedobjects.nos.client.web.component.DebugPane;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.component.ViewPane;


public class DynamicHtmlPage extends AbstractHtmlPage implements Page {
    private Component crumbs;
    private DebugPane debugPane;
    private final Block navigation = new Div(null, "navigation");
    private final ViewPane viewPane = new ViewDiv();

    public DynamicHtmlPage(String styleSheet, String header, String footer) {
        super(styleSheet, header, footer);
    }

    public Block getNavigation() {
        return navigation;
    }

    public ViewPane getViewPane() {
        return viewPane;
    }

    public void setCrumbs(Component crumbs) {
        this.crumbs = crumbs;
    }

    public void setDebug(DebugPane debugPane) {
        this.debugPane = debugPane;
    }

    protected void writeContent(PrintWriter writer) {
        if (debugPane != null) {
            debugPane.write(writer);
        } else {
            writer.println();
            writer.println("<div id=\"body\">");
            navigation.write(writer);
            if (crumbs != null) {
                crumbs.write(writer);
            }

            viewPane.write(writer);
            writer.println();
            writer.println("</div>");
        }
    }
}

// Copyright (c) Naked Objects Group Ltd.
