package org.nakedobjects.nos.client.web.html;

import java.io.PrintWriter;

import org.nakedobjects.noa.NakedObjectRuntimeException;
import org.nakedobjects.nos.client.web.component.DebugPane;


public class HtmlDebug implements DebugPane {
    private static final String SPACES = "                                    ";
    private StringBuffer debug = new StringBuffer();
    private int indent;

    public void addSection(String title) {
        if (debug.length() > 0) {
            appendln("</pre>");
        }
        appendln("<h2>");
        appendln(title);
        appendln("</h2><pre>");
    }

    public void appendln(String text) {
        debug.append(SPACES.substring(0, indent * 3));
        debug.append(text);
        debug.append("\n");
    }

    public void write(PrintWriter writer) {
        if (debug.length() > 0) {
            writer.print(debug.toString());
            writer.println("</pre>");
        }
    }
    
    public void indent() {
        indent++;
    }
    
    public void unindent() {
        if(indent == 0){
            throw new NakedObjectRuntimeException();
        }
        indent--;
    }
}

// Copyright (c) Naked Objects Group Ltd.
