package org.nakedobjects.nos.client.web.html;

import java.io.PrintWriter;

import org.nakedobjects.nos.client.web.component.Component;
import org.nakedobjects.nos.client.web.component.ImageLookup;

public class Service implements Component {

    private final String id;
    private final String name;
    private final String iconName;

    public Service(String id, String name, String iconName) {
        this.id = id;
        this.name = name;
        this.iconName = iconName;
    }

    public void write(PrintWriter writer) {
        writer.print("<div class=\"item\">");
        
        writer.print("<a href=\"");
        writer.print("serviceOption.app?id=");
        writer.print(id);
        writer.print("\"><img src=\"images/");
        writer.print(ImageLookup.image(iconName));
        writer.print("\" alt=\"service\" />");
        writer.print(name);
        writer.print("</a>");
        
        writer.println("</div>");
    }

}


// Copyright (c) Naked Objects Group Ltd.
