package org.nakedobjects.nos.client.web.object;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.reflect.OneToManyAssociation;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nos.client.web.component.Table;
import org.nakedobjects.nos.client.web.component.ViewPane;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.Request;
import org.nakedobjects.nos.client.web.request.TableBuilder;


public class FieldCollectionView extends AbstractObjectView {
    protected void doExecute(Context context, ViewPane content, NakedObject object, String field) {
        String id = context.mapObject(object);
        NakedObjectSpecification specification = object.getSpecification();

        OneToManyAssociation collection = (OneToManyAssociation) specification.getField(field);
        NakedObjectsContext.getObjectPersistor().resolveField(object, collection);
        context.addCollectionFieldCrumb(collection.getName());
        content.add(context.getComponentFactory().createHeading(collection.getName()));
        Table table = TableBuilder.createTable(context, id, object, collection);
        content.add(table);
        if (collection.isUsable().isAllowed() && collection.isUsable(object).isAllowed()) {
            content.add(context.getComponentFactory().createAddOption(id, collection.getId()));
        }
    }

    public String name() {
        return Request.FIELD_COLLECTION_COMMAND;
    }

}

// Copyright (c) Naked Objects Group Ltd.
