package org.nakedobjects.nos.client.web.object;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.reflect.OneToManyAssociation;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.request.Action;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.ForwardRequest;
import org.nakedobjects.nos.client.web.request.Request;

public class RemoveItemFromCollection implements Action {

    public void execute(Request request, Context context, Page page) {
        String objectId = request.getObjectId();
        String elementId = request.getElementId();
        String collectionField = request.getProperty();

        NakedObject target = context.getMappedObject(objectId);
        NakedObject element = context.getMappedObject(elementId);
        NakedObjectSpecification specification = target.getSpecification();
        OneToManyAssociation field = (OneToManyAssociation) specification.getField(collectionField);
        field.removeElement(target, element);
        
        request.forward(ForwardRequest.viewObject(objectId, collectionField));
    }

    public String name() {
        return "remove";
    }

}


// Copyright (c) Naked Objects Group Ltd.
