package org.nakedobjects.nos.client.web.object;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.persist.NakedObjectPersistor;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.request.Action;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.ForwardRequest;
import org.nakedobjects.nos.client.web.request.Request;

public class Save implements Action {

    public void execute(Request request, Context context, Page page) {
        NakedObject object = context.getMappedObject(request.getObjectId());
        NakedObjectPersistor persistor = NakedObjectsContext.getObjectPersistor();
        persistor.startTransaction();
        persistor.makePersistent(object);
        persistor.endTransaction();
        // return to view 
        request.forward(ForwardRequest.viewObject(request.getObjectId()));
    }

    public String name() {
        return "save";
    }

}


// Copyright (c) Naked Objects Group Ltd.
