package org.nakedobjects.nos.client.web.request;

import org.nakedobjects.noa.adapter.NakedCollection;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.ToString;


public class CollectionCrumb implements Crumb {
    private final String collectionId;
    private final String title;

    public CollectionCrumb(String collectionId, NakedCollection collection) {
        this.collectionId = collectionId;
        title = collection.titleString();
    }

    public void debug(DebugString string) {
        string.appendln("Collection Crumb");
        string.appendln("object", collectionId);
        string.appendln("title", title);
    }

    public String title() {
        return title;
    }

    public String toString() {
        return new ToString(this).append(title()).toString();
    }

    public Request changeContext() {
        return ForwardRequest.listCollection(collectionId);
    }
}

// Copyright (c) Naked Objects Group Ltd.
