package org.nakedobjects.nos.client.web.request;

import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.spec.Features;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.ToString;


public class ObjectCrumb implements Crumb {
    private final String objectId;
    private final boolean isService;
    private final String title;

    public ObjectCrumb(String objectId, NakedReference object) {
        this.objectId = objectId;
        title = object.titleString();
        isService = Features.isService(object.getSpecification());
    }

    public void debug(DebugString string) {
        string.appendln("Object Crumb");
        string.appendln("object", objectId);
        string.appendln("title", title);
        string.appendln("for service", isService);
    }
    
    public String title() {
        return title;
    }

    public String toString() {
        return new ToString(this).append(title()).toString();
    }
    
    public Request changeContext() {
        if (isService) {
            return ForwardRequest.viewService(objectId);
        } else {
            return ForwardRequest.viewObject(objectId);
        }

    }
}

// Copyright (c) Naked Objects Group Ltd.
