package org.nakedobjects.nos.client.web.request;

import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.NotImplementedException;
import org.nakedobjects.nof.core.util.ToString;


public class ObjectFieldCrumb implements Crumb {
    private final String fieldName;

    public ObjectFieldCrumb(String fieldName) {
        this.fieldName = fieldName;
    }

    public void debug(DebugString string) {
        string.appendln("Object Field Crumb");
        string.appendln("field name", fieldName);
    }

    public String title() {
        return fieldName;
    }

    public String toString() {
        return new ToString(this).append(title()).toString();
    }

    public Request changeContext() {
        throw new NotImplementedException();
    }
}

// Copyright (c) Naked Objects Group Ltd.
