package org.nakedobjects.nos.client.web.request;

import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.ToString;


public class TaskCrumb implements Crumb {
    private final Task task;

    public TaskCrumb(Task task) {
        this.task = task;
    }

    public Task getTask() {
        return task;
    }

    public void debug(DebugString string) {
        string.appendln("Task Crumb");
        string.appendln("task", task);
        
        task.debug(string);
    }

    public String title() {
        return task.getName();
    }

    public String toString() {
        return new ToString(this).append(title()).toString();
    }
    
    public Request changeContext() {
        return ForwardRequest.task(task);
    }

}

// Copyright (c) Naked Objects Group Ltd.
