package org.nakedobjects.nos.client.web.servlet;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.nof.core.security.PasswordAuthenticationRequest;
import org.nakedobjects.nof.core.system.Monitor;
import org.nakedobjects.nos.client.web.html.HtmlComponentFactory;
import org.nakedobjects.nos.client.web.html.LogonFormPage;
import org.nakedobjects.nos.client.web.request.Context;


public class Logon extends HttpServlet {
    private static final Logger LOG = Logger.getLogger(Logon.class);
    private static final long serialVersionUID = 1L;

    protected void doPost(final HttpServletRequest request, final HttpServletResponse response) throws ServletException,
            IOException {
        String user = request.getParameter("username");
        String password = request.getParameter("password");
        PasswordAuthenticationRequest passwordAuthenticationRequest = new PasswordAuthenticationRequest(user, password);

        if (user == null) {
            prompt(response, "", "", "");
        } else {
            Session session = null;
            session = SystemAccess.authenticate(passwordAuthenticationRequest);
            if (session != null) {
                Context context = new Context(new HtmlComponentFactory());
                context.setSession(session);
                HttpSession httpSession = request.getSession(true);
                httpSession.setAttribute("nof-context", context);
                LOG.info("created session: " + httpSession);
                loggedIn(response, user);
            } else {
                prompt(response, user, password, "error");
            }
            // sendResponse(response, user, session);
        }

    }

    protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1) throws ServletException, IOException {
        doPost(arg0, arg1);
    }

    /*
     * private void sendResponse(final HttpServletResponse response, final String user, final Session session)
     * throws IOException { boolean loggedIn = session != null; if (loggedIn) { loggedIn(response, user); }
     * else { prompt(response, user); } }
     */
    private void prompt(final HttpServletResponse response, final String user, final String password, final String message)
            throws IOException {
        response.setContentType("text/html");
        HtmlComponentFactory factory = new HtmlComponentFactory();
        LogonFormPage page = factory.createLogonPage(user, password);
        page.write(response.getWriter());
    }

    private void loggedIn(final HttpServletResponse response, final String user) throws IOException {
        Monitor.addEvent("Web", "Logon - " + user);
        response.sendRedirect("start.app");
    }

}

// Copyright (c) Naked Objects Group Ltd.
