package org.nakedobjects.nos.client.web.servlet;

import javax.servlet.http.HttpServletRequest;

import org.nakedobjects.nos.client.web.request.Request;


public class ServletRequest implements Request {
    private Request forwardRequest;
    private final HttpServletRequest request;
    private String requestType;

    public ServletRequest(HttpServletRequest request) {
        this.request = request;

        String path = request.getServletPath();
        int from = path.lastIndexOf('/');
        int to = path.lastIndexOf('.');
        requestType = path.substring(from + 1, to);
    }

    public void forward(Request forwardRequest) {
        this.forwardRequest = forwardRequest;
    }

    public String getActionId() {
        return request.getParameter("action");
    }

    public String getProperty() {
        return request.getParameter("field");
    }

    public String getElementId() {
        return request.getParameter("element");
    }
    
    public String getFieldEntry(int i) {
        return request.getParameter("fld" + i);
    }

    public String getTaskId() {
        return request.getParameter("id");
    }

    public Request getForward() {
        return forwardRequest;
    }

    public String getName() {
        return  request.getParameter("name");
    }
    
    public String getObjectId() {
        return request.getParameter("id");
    }

    public String getRequestType() {
        return requestType;
    }

    public String getButtonName() {
        return request.getParameter("button");
    }
    
    public String toString() {
        return "ServletRequest " + request.getRequestURI() + "?" + request.getQueryString();
    }

}

// Copyright (c) Naked Objects Group Ltd.
