package org.nakedobjects.nos.client.web.session;

import org.nakedobjects.nof.core.util.AboutNakedObjects;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.component.ViewPane;
import org.nakedobjects.nos.client.web.request.Action;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.Request;

public class Welcome implements Action {
    public static final String COMMAND = "start";

    public void execute(Request request, Context context, Page page) {
        page.setTitle("NOF Application");
        
        context.init();

        ViewPane content = page.getViewPane();
        content.setTitle("Welcome", null);
        
        String name = AboutNakedObjects.getApplicationName();
        if (name == null) {
            name = AboutNakedObjects.getFrameworkName();
        }
        content.add(context.getComponentFactory().createInlineBlock("message", "Welcome to " +   name + ", accessed via the Web Viewer", null));
    }

    public String name() {
        return COMMAND;
    }

}


// Copyright (c) Naked Objects Group Ltd.
