package org.nakedobjects.nos.client.web.task;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.reflect.OneToManyAssociation;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.request.Action;
import org.nakedobjects.nos.client.web.request.ActionException;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.ForwardRequest;
import org.nakedobjects.nos.client.web.request.Request;

public class AddItemToCollection implements Action {

    public void execute(Request request, Context context, Page page) {
        String collectionField = request.getProperty();
        
        String idString = request.getObjectId();
        if(idString == null) {
            throw new ActionException("Task no longer in progress");
        }
        NakedObject object = context.getMappedObject(idString);
        NakedObjectSpecification specification = object.getSpecification();
        OneToManyAssociation field = (OneToManyAssociation) specification.getField(collectionField);
        AddItemToCollectionTask addTask = new AddItemToCollectionTask(context, object, field);
        context.addTaskCrumb(addTask);
        request.forward(ForwardRequest.task(addTask));
    }

    public String name() {
        return "add";
    }

}


// Copyright (c) Naked Objects Group Ltd.
