package org.nakedobjects.nos.client.web.task;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.ResolveState;
import org.nakedobjects.nos.client.web.component.Page;
import org.nakedobjects.nos.client.web.request.Action;
import org.nakedobjects.nos.client.web.request.ActionException;
import org.nakedobjects.nos.client.web.request.Context;
import org.nakedobjects.nos.client.web.request.ForwardRequest;
import org.nakedobjects.nos.client.web.request.Request;


public class EditObject implements Action {
    
    public void execute(Request request, Context context, Page page) {
        String idString = request.getObjectId();
        if(idString == null) {
            throw new ActionException("Task no longer in progress");
        }
        NakedObject object = context.getMappedObject(idString);
        if (object.getResolveState() != ResolveState.TRANSIENT) {
            context.setObjectCrumb(object);
        }
        EditTask editTask = new EditTask(context, object);
        context.addTaskCrumb(editTask);
        request.forward(ForwardRequest.task(editTask));
    }

    public String name() {
        return Request.EDIT_COMMAND;
    }
}

// Copyright (c) Naked Objects Group Ltd.
